<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Hello!</title>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
  </head>
  <body>
    <canvas id="c" style="width: 500px; height: 500px"></canvas>
    <script>
      let canvas = document.getElementById("c");
      let ctx = canvas.getContext("2d");

      let components = [];
      let round = 0;
      function loop() {
        let alive = true;
        ctx.save();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        
        for (let component of components) {
          if (component.getType() == "Obstacle") {
            if (round++ % 3 == 0 && Math.random() < 0.4) {
              component.y = component.y + 1;
              if (Math.random() < 0.2) {
                component.x = component.x + 1;
              } else if (Math.random() > 0.8) {
                component.x = component.x - 1;
              }
            }
          } else if (component.getType() == "Bullet") {
            component.y = component.y - 1;
          }
          component.update();
        }
        //now, we check overlap between all pairs of components
        outer: for(let i=0; i<components.length; i++){
          for(let j=i+1; j<components.length; j++){
            if(!components[i].visible || !components[j].visible){
              //then skip
              continue;
            }
            if(isOverlap(components[i], components[j])){
              if((components[i].getType()=="Obstacle" && components[j].getType()=="MainComponent") || 
                 (components[j].getType()=="Obstacle" && components[i].getType()=="MainComponent")){
                //collision between Obstacle & MainComponent
                alive=false;
                break outer;
              }else if((components[i].getType()=="Obstacle" && components[j].getType()=="Bullet") || 
                 (components[j].getType()=="Obstacle" && components[i].getType()=="Bullet")){
                //collision between Obstacle & Bullet
                components[i].visible=false;
                components[j].visible=false;
              }
            }
          }
        }
        let oldComponents=components;
        components=[];
        //check game state & collect new sets of components to save memory
        for(let component of oldComponents){
          if(!component.visible){
            continue;
          }
          if(component.getType()=="Obstacle" && component.y>=canvas.height){
            alive=false;
            break;
          }
          if(component.y>=0 && component.y<=canvas.height){
            components.push(component);
          }
        }
        
        ctx.restore();
        if (alive) {
          setTimeout(function() {
            window.requestAnimationFrame(loop);
          }, 1000 / 25);
        }else{
          alert("fail!");
        }
      }
      window.requestAnimationFrame(loop);

      class Component {
        constructor(x, y, width, height) {
          this.x = x;
          this.y = y;
          this.width = width;
          this.height = height;
          this.visible = true;
        }
        getType() {
          return "unknown";
        }
        update() {}
      }

      class MainComponent extends Component {
        constructor(x, y) {
          super(x, y, 5, 5);
        }
        getType() {
          return "MainComponent";
        }
        update() {
          if (this.visible) {
            ctx.fillStyle = "#0000ff";
            ctx.fillRect(this.x, this.y, this.width, this.height);
          }
        }
      }

      class Obstacle extends Component {
        constructor(x, y) {
          super(x, y, 10, 10);
        }
        getType() {
          return "Obstacle";
        }
        update() {
          if (this.visible) {
            ctx.fillStyle = "#916f10";
            ctx.fillRect(this.x, this.y, this.width, this.height);
          }
        }
      }

      class Bullet extends Component {
        constructor(x, y) {
          super(x, y, 2, 2);
        }
        getType() {
          return "Bullet";
        }
        update() {
          if (this.visible) {
            ctx.fillStyle = "#ff0000";
            ctx.fillRect(this.x, this.y, this.width, this.height);
          }
        }
      }

      function isOverlap(obj1, obj2) {
        let overlap = !(
          obj1.x + obj1.width < obj2.x ||
          obj1.x > obj2.x + obj2.width ||
          obj1.y + obj1.height < obj2.y ||
          obj1.y > obj2.y + obj2.height
        );
        return overlap;
      }

      let mainComponent = new MainComponent(
        canvas.width / 2,
        canvas.height - 10
      );
      components.push(mainComponent);
      for (let y = 0; y < 10; y++) {
        for (let x = 0; x < 5; x++) {
          let ob1 = new Obstacle(
            Math.floor(Math.random() * canvas.width),
            (y + 1) * 5
          );
          components.push(ob1);
        }
      }

      function onKeyDown(e) {
        if (e.keyCode == 39) {
          mainComponent.x = mainComponent.x + 1;
        } else if (e.keyCode == 37) {
          mainComponent.x = mainComponent.x - 1;
        }
        mainComponent.x = mainComponent.x % canvas.width;
        if (mainComponent.x < 0) {
          mainComponent.x = canvas.width - 1;
        }
      }

      function onClick(e) {
        let bullet = new Bullet(mainComponent.x, mainComponent.y);
        components.push(bullet);
      }

      window.addEventListener("keydown", onKeyDown);
      window.addEventListener("click", onClick);
    </script>
  </body>
</html>
